package com.sf.msg.consumers;

package ..deTemp.1735008975875;

import com.sf.msg.bean.AlarmMsgBean;
import com.sf.msg.bean.SmsPlanBean;
import com.sf.msg.bean.SmsProcessBean;
import com.sf.msg.service.DmsMessageSendService;
import com.sf.msg.service.SmsWxRestParaHandler;
import com.sf.web.dms.common.ws.handler.MessageConsumer;
import com.smartframework.web.core.http.HttpResponse;
import com.smartframework.web.core.http.IParaHandler;
import com.smartframework.web.core.utils.ClientFactory;
import com.smartframework.web.core.utils.Constants;
import com.smartframework.web.core.utils.DateUtil;
import com.smartframework.web.core.utils.IMSenderUtil;
import com.smartframework.web.core.utils.JdbcClient;
import com.smartframework.web.core.utils.JsonUtil;
import com.smartframework.web.core.utils.ParameterUtils;
import com.smartframework.web.core.utils.RestClient;
import com.smartframework.web.core.utils.RthdbDao;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import org.apache.commons.lang.StringUtils;

public class SmsMessageConsumer extends MessageConsumer {
  static ConcurrentHashMap<String, Integer> brkStatusMap = null;
  
  static ConcurrentHashMap<String, List<String>> tableSubsMap = null;
  
  static SmsProcessBean smsProcessBean = new SmsProcessBean();
  
  static ConcurrentHashMap<String, String> headerBrkMap = null;
  
  static boolean isInit = false;
  
  public SmsMessageConsumer() {
    createJdbcClient();
    createRthdbDao();
  }
  
  public static String loadCurOrg(JdbcClient loadDao, Integer user_id) {
    String sql = "select id from sys_organization start with id in(select org_id from sys_org_user_link where user_id=";
    sql = sql + user_id + ") connect by prior id = pid order by id";
    List<Map<String, Object>> list = loadDao.queryForList(sql);
    List<String> idList = new ArrayList<>();
    idList.add("-1");
    for (Map<String, Object> one : list)
      idList.add(String.valueOf(one.get("id"))); 
    return StringUtils.join(idList, ",");
  }
  
  public static List<String> loadDevsByFeeder(JdbcClient loadDao, String fdId, Integer user_id) {
    List<String> devs = new ArrayList<>();
    loadDevsReaction(loadDao, "con_feeder", fdId, "", user_id, devs);
    return devs;
  }
  
  public static List<String> loadDevsByStstion(JdbcClient loadDao, String stId, Integer user_id) {
    List<String> devs = new ArrayList<>();
    Integer isAuth = Constants.getInteger("dms.sms.auth", Integer.valueOf(0));
    if (isAuth.intValue() == 0) {
      loadDevsReaction(loadDao, "con_station", stId, "", user_id, devs);
    } else {
      List<Map<String, Object>> tmp = loadDao.queryForList("select distinct id from con_feeder where container_id=" + stId + " and id in(select container_id from auth_orgrtu where org_id in(" + loadCurOrg(loadDao, user_id) + "))");
      for (Map<String, Object> one : tmp) {
        String fd = String.valueOf(one.get("id"));
        loadDevsReaction(loadDao, "con_feeder", fd, "", user_id, devs);
      } 
      for (String tanle : tableSubsMap.get("con_station")) {
        if (tanle == "con_feeder")
          continue; 
        tmp = new ArrayList<>();
        tmp = loadDao.queryForList("select id from " + tanle + " where container_id=" + stId);
        for (Map<String, Object> one : tmp) {
          String id = String.valueOf(one.get("id"));
          loadDevsReaction(loadDao, tanle, id, "", user_id, devs);
        } 
      } 
    } 
    return devs;
  }
  
  public static List<String> loadDevsByFilter(JdbcClient loadDao, String filter, Integer user_id) {
    List<String> devs = new ArrayList<>();
    if (ParameterUtils.isEmptyOrNull(filter))
      return devs; 
    Integer isAuth = Constants.getInteger("dms.sms.auth", Integer.valueOf(0));
    String sql = "";
    if (isAuth.intValue() == 0) {
      sql = "select id from obj_dev where filter='" + filter + "'";
      List<Map<String, Object>> tmp = loadDao.queryForList(sql);
      for (Map<String, Object> one : tmp) {
        String id = String.valueOf(one.get("id"));
        if (devs.contains(id))
          continue; 
        devs.add(id);
      } 
    } else {
      sql = "select container_id from auth_orgrtu where org_id in(" + loadCurOrg(loadDao, user_id) + ")";
      List<Map<String, Object>> tmp = loadDao.queryForList(sql);
      for (Map<String, Object> one : tmp) {
        String fd = String.valueOf(one.get("containerId"));
        loadDevsReaction(loadDao, "con_feeder", fd, filter, user_id, devs);
      } 
    } 
    return devs;
  }
  
  public static void loadDevsReaction(JdbcClient loadDao, String con_tab, String con_id, String filter, Integer user_id, List<String> devs) {
    String sql = "select id,filter from obj_dev where container_id=" + con_id;
    if (!ParameterUtils.isEmptyOrNull(filter))
      sql = "select id,filter from obj_dev where container_id=" + con_id + " and filter='" + filter + "'"; 
    List<Map<String, Object>> tmp = loadDao.queryForList(sql);
    for (Map<String, Object> one : tmp) {
      String id = String.valueOf(one.get("id"));
      if (devs.contains(id))
        continue; 
      String ff = String.valueOf(one.get("filter"));
      if (!ParameterUtils.isEmptyOrNull(filter) && 
        ff != filter)
        continue; 
      devs.add(id);
    } 
    if (!tableSubsMap.containsKey(con_tab))
      return; 
    for (String tanle : tableSubsMap.get(con_tab)) {
      List<Map<String, Object>> cons = loadDao.queryForList("select id from " + tanle + " where container_id=" + con_id);
      for (Map<String, Object> one : cons) {
        String id = String.valueOf(one.get("id"));
        if (!devs.contains(id))
          devs.add(id); 
        loadDevsReaction(loadDao, tanle, id, filter, user_id, devs);
      } 
    } 
  }
  
  public static void loadContainer(JdbcClient loadDao, Integer user_id, SmsProcessBean sms) {
    if (!sms.getUserStations().containsKey(user_id))
      sms.getUserStations().put(user_id, new ArrayList()); 
    if (!sms.getUserFeeders().containsKey(user_id))
      sms.getUserFeeders().put(user_id, new ArrayList()); 
    List<Map<String, Object>> list = loadDao.queryForList("select container_id,station_id from auth_orgrtu where org_id in(" + loadCurOrg(loadDao, user_id) + ")");
    for (Map<String, Object> o : list) {
      if (ParameterUtils.isEmptyOrNull(o.get("containerId")))
        continue; 
      String fd = String.valueOf(o.get("containerId"));
      if (!((List)sms.getUserFeeders().get(user_id)).contains(fd))
        ((List<String>)sms.getUserFeeders().get(user_id)).add(fd); 
      if (!ParameterUtils.isEmptyOrNull(o.get("stationId"))) {
        String st = String.valueOf(o.get("stationId"));
        if (!((List)sms.getUserStations().get(user_id)).contains(st))
          ((List<String>)sms.getUserStations().get(user_id)).add(st); 
      } 
    } 
  }
  
  public static List<String> loadPhone(JdbcClient loadDao, Integer user_id) {
    List<String> phones = new ArrayList<>();
    Integer phoneSrc = Constants.getInteger("dms.sms.phone.source", Integer.valueOf(0));
    if (phoneSrc.intValue() == 0) {
      List<Map<String, Object>> list1 = loadDao.queryForList("select phone from sms_phone_user_link where user_id=" + user_id);
      for (Map<String, Object> one : list1) {
        String phone = String.valueOf(one.get("phone"));
        if (ParameterUtils.isEmptyOrNull(phone) || 
          phone.length() < 11 || 
          phones.contains(phone))
          continue; 
        phones.add(phone);
      } 
      list1 = loadDao.queryForList("select phone from sys_web_user where id=" + user_id);
      for (Map<String, Object> one : list1) {
        String phone = String.valueOf(one.get("phone"));
        if (ParameterUtils.isEmptyOrNull(phone) || 
          phone.length() < 11 || 
          phones.contains(phone))
          continue; 
        phones.add(phone);
      } 
    } else if (phoneSrc.intValue() == 1) {
      List<Map<String, Object>> list2 = loadDao.queryForList("select distinct phone from sys_web_user where id in(select distinct user_id from sys_org_user_link where org_id in(" + loadCurOrg(loadDao, user_id) + "))");
      for (Map<String, Object> one : list2) {
        String phone = String.valueOf(one.get("phone"));
        if (ParameterUtils.isEmptyOrNull(phone) || 
          phone.length() < 11 || 
          phones.contains(phone))
          continue; 
        phones.add(phone);
      } 
    } else {
      List<Map<String, Object>> list1 = loadDao.queryForList("select phone from sms_phone_user_link where user_id=" + user_id);
      for (Map<String, Object> one : list1) {
        String phone = String.valueOf(one.get("phone"));
        if (ParameterUtils.isEmptyOrNull(phone) || 
          phone.length() < 11 || 
          phones.contains(phone))
          continue; 
        phones.add(phone);
      } 
      String sql = "select distinct phone from sys_web_user where id in(select distinct user_id from sys_org_user_link where org_id in(" + loadCurOrg(loadDao, user_id) + "))";
      List<Map<String, Object>> list2 = loadDao.queryForList(sql);
      for (Map<String, Object> one : list2) {
        String phone = String.valueOf(one.get("phone"));
        if (ParameterUtils.isEmptyOrNull(phone) || 
          phone.length() < 11 || 
          phones.contains(phone))
          continue; 
        phones.add(phone);
      } 
    } 
    return phones;
  }
  
  public static synchronized void reLoad() {
    JdbcClient loadDao = ClientFactory.getInstance().getJdbcClient();
    RthdbDao rthdb = ClientFactory.getInstance().getRthdbClient();
    isInit = false;
    if (ParameterUtils.isEmptyOrNull(brkStatusMap))
      brkStatusMap = new ConcurrentHashMap<>(); 
    brkStatusMap.clear();
    List<Map<String, Object>> list = new ArrayList<>();
    list = rthdb.queryForList("select id,status from real_scada_obj_dev where filter in('breaker')");
    for (Map<String, Object> m : list) {
      String id = String.valueOf(m.get("id"));
      String status = String.valueOf(m.get("status"));
      Integer bSend = Integer.valueOf(0);
      String a = Integer.toBinaryString(Integer.valueOf(status).intValue());
      if (a.length() >= 13 && a.charAt(12) == '0')
        bSend = Integer.valueOf(1); 
      brkStatusMap.put(id, bSend);
    } 
    logger.info(String.format("Fa开关总共%d个", new Object[] { Integer.valueOf(brkStatusMap.size()) }));
    if (ParameterUtils.isEmptyOrNull(headerBrkMap))
      headerBrkMap = new ConcurrentHashMap<>(); 
    headerBrkMap.clear();
    list = rthdb.queryForList("select id,head_brk from real_scada_con_feeder");
    for (Map<String, Object> m : list) {
      String id = String.valueOf(m.get("id"));
      String headBrk = String.valueOf(m.get("headBrk"));
      headerBrkMap.put(headBrk, id);
    } 
    logger.info(String.format("馈线首开关总共%d个", new Object[] { Integer.valueOf(headerBrkMap.size()) }));
    if (ParameterUtils.isEmptyOrNull(tableSubsMap)) {
      tableSubsMap = new ConcurrentHashMap<>();
      tableSubsMap.clear();
      Map<String, String> con_1_map = new HashMap<>();
      list = new ArrayList<>();
      list = loadDao.queryForList("select name,tablename from con_1_description where tablename like 'con_%'");
      for (Map<String, Object> one : list) {
        String name = String.valueOf(one.get("name"));
        String table_name = String.valueOf(one.get("tablename"));
        if (name.equals("division") || name.equals("convertorend") || name.equals("company") || name
          .equals("bay") || name.equals("convertor"))
          continue; 
        con_1_map.put(name, table_name);
      } 
      for (String name : con_1_map.keySet()) {
        String table_name = con_1_map.get(name);
        list = new ArrayList<>();
        String str1 = "";
        Integer dbType = Constants.getInteger("dms.sms.dbtype", Integer.valueOf(5));
        if (dbType.intValue() == 4) {
          str1 = "WITH RECURSIVE r AS (SELECT * FROM con_1_relation WHERE containername='" + name;
          str1 = str1 + "' union ALL SELECT con_1_relation.* FROM con_1_relation, r WHERE con_1_relation.containername = r.membername) SELECT membername FROM r ORDER BY id";
        } else {
          str1 = "select membername from con_1_relation start with containername='" + name;
          str1 = str1 + "' connect by prior membername = containername order by id";
        } 
        list = loadDao.queryForList(str1);
        for (Map<String, Object> one : list) {
          String member_name = String.valueOf(one.get("membername"));
          String tabname = con_1_map.get(member_name);
          if (member_name.equals("division") || member_name.equals("convertorend") || member_name.equals("company") || member_name
            .equals("bay") || member_name.equals("convertor"))
            continue; 
          if (!tableSubsMap.containsKey(table_name))
            tableSubsMap.put(table_name, new ArrayList<>()); 
          if (((List)tableSubsMap.get(table_name)).contains(tabname))
            continue; 
          ((List<String>)tableSubsMap.get(table_name)).add(tabname);
        } 
      } 
    } 
    String str_watch = Constants.getString("dms.msg.sms.handler.watch.types", "");
    if (ParameterUtils.isEmptyOrNull(str_watch))
      str_watch = ""; 
    boolean watchEnabled = false;
    smsProcessBean.clear();
    list = new ArrayList<>();
    String sql = "select a.alarm_type,a.status,a.infer_name,b.device_type,b.expired_date,b.is_enabled,b.send_plan,b.template_id,c.user_id from sms_alarm_type_def a,sms_alarm_dev_type_link b,sms_sub_dev_link c where a.id=b.alarm_type and b.id=c.alarm_dev_link_id";
    list = loadDao.queryForList(sql);
    for (Map<String, Object> m : list) {
      String alarmType = String.valueOf(m.get("alarmType"));
      String status = String.valueOf(m.get("status"));
      String subKey = String.format("%s.%s", new Object[] { alarmType, status });
      String postfix = "";
      if (!ParameterUtils.isEmptyOrNull(m.get("inferName")))
        postfix = String.valueOf(m.get("inferName")); 
      String device_type = String.valueOf(m.get("deviceType"));
      Integer is_enabled = Integer.valueOf(1);
      if (!ParameterUtils.isEmptyOrNull(m.get("isEnabled")))
        is_enabled = Integer.valueOf(String.valueOf(m.get("isEnabled"))); 
      Integer send_plan = Integer.valueOf(1);
      if (!ParameterUtils.isEmptyOrNull(m.get("sendPlan")))
        send_plan = Integer.valueOf(String.valueOf(m.get("sendPlan"))); 
      send_plan = Integer.valueOf(1);
      if (ParameterUtils.isEmptyOrNull(m.get("templateId"))) {
        logger.info(String.format("告警类型:%s,设备类型:%s 的短信模板为空，当前订阅信息无效，涉及到的设备将无法发送短信", new Object[] { subKey, device_type }));
        continue;
      } 
      String template_id = String.valueOf(m.get("templateId"));
      Integer user_id = Integer.valueOf(String.valueOf(m.get("userId")));
      if (!smsProcessBean.getUserPhones().containsKey(user_id))
        smsProcessBean.getUserPhones().put(user_id, loadPhone(loadDao, user_id)); 
      if (!smsProcessBean.getUserFeeders().containsKey(user_id))
        loadContainer(loadDao, user_id, smsProcessBean); 
      SmsPlanBean alm = smsProcessBean.loadOnePlan(subKey, send_plan, template_id, user_id);
      alm.setPostfix(postfix);
      Long start = Long.valueOf(System.currentTimeMillis());
      if (device_type.startsWith("1021")) {
        if (!alm.getDevs().contains(device_type))
          alm.getDevs().add(device_type); 
      } else if (!alm.getdTypes().contains(device_type)) {
        alm.getdTypes().add(device_type);
      } 
      if (smsProcessBean.getAlmTypeDevs().containsKey(subKey))
        for (String id : smsProcessBean.getAlmTypeDevs().get(subKey)) {
          if (alm.getDevs().contains(id))
            continue; 
          alm.getDevs().add(id);
        }  
      for (String phone : smsProcessBean.getUserPhones().get(user_id)) {
        if (alm.getPhones().contains(phone))
          continue; 
        alm.getPhones().add(phone);
      } 
    } 
    logger.info(String.format("订阅列表个数：%d", new Object[] { Integer.valueOf(smsProcessBean.getSubMap().size()) }));
    for (String subKey : smsProcessBean.getSubMap().keySet()) {
      watchEnabled = (str_watch.indexOf(subKey) > -1);
      List<SmsPlanBean> smmList = (List<SmsPlanBean>)smsProcessBean.getSubMap().get(subKey);
      if (watchEnabled)
        logger.info(String.format("订阅%s,涉及%d个发送方式", new Object[] { subKey, Integer.valueOf(smmList.size()) })); 
      for (SmsPlanBean o : smmList) {
        logger.debug(String.format("短信类型:%s,短信模板:%s,发送计划:%d，用户:%d，涉及发送短信人员:%s, 涉及要发送短信的设备类型:%s,已经读取的设备个数:%d", new Object[] { subKey, o
                .getTemplate_id(), o.getSend_plan(), o.getUser_id(), o.getPhones().toString(), StringUtils.join(o.getdTypes(), ","), Integer.valueOf(o.getDevs().size()) }));
      } 
    } 
    try {
      loadDao.close();
    } catch (Exception e) {
      logger.warn("关闭JDBC连接时异常，可能出现内存泄漏。");
    } 
    try {
      rthdb.close();
    } catch (Exception e) {
      logger.warn("关闭RTHDB连接时异常，可能出现内存泄漏。");
    } 
    isInit = true;
  }
  
  public String getOrgCode() {
    if (Constants.integerConfigIsEnabled("dms.sms.load.alarm"))
      return ""; 
    return Constants.getAppPrefixedPara("orgCode");
  }
  
  public void handleMsg() throws Exception {
    String topic = getTopic();
    Map<String, Object> msgData = getData();
    if (!"alarm_listen".equals(getTopic())) {
      logger.info("MSGDATA,消息主题不是alarm_listen");
      return;
    } 
    logger.debug("收到短信可以处理的消息，topic:" + getTopic());
    handle(msgData);
  }
  
  public void handle(Map<String, Object> msgData) {
    String str_watch = Constants.getString("dms.msg.sms.handler.watch.types");
    if (ParameterUtils.isEmptyOrNull(str_watch))
      str_watch = ""; 
    boolean watchEnabled = false;
    String str_dev_watch = Constants.getString("dms.msg.sms.handler.watch.devIds");
    if (ParameterUtils.isEmptyOrNull(str_dev_watch))
      str_dev_watch = ""; 
    List<AlarmMsgBean> alarmMapNew = extractAlarmFromMsgContentNew(msgData);
    for (AlarmMsgBean alarmMap : alarmMapNew) {
      watchEnabled = (str_watch.indexOf(alarmMap.subKey()) > -1);
      if (!watchEnabled);
      if (alarmMap == null) {
        if (watchEnabled)
          logger.info("告警 内容不符合解析要求,解析失败"); 
        continue;
      } 
      if (!alarmMap.isValid()) {
        if (watchEnabled)
          logger.info(String.format("解析结果:%s 未解析到有效告警", new Object[] { alarmMap.getAlarm_str() })); 
        continue;
      } 
      if (alarmMap.getAlarm_type() == null || alarmMap.getStatus() == null) {
        if (watchEnabled)
          logger.info("告警信息必须包括alarm_type和status字段, 内容:" + alarmMap.getAlarm_str()); 
        continue;
      } 
      if (ParameterUtils.isEmptyOrNull(alarmMap.getDev_id())) {
        if (watchEnabled)
          logger.info("告警信息dev_id不存在或者为空，不发送短信"); 
        continue;
      } 
      if (!smsProcessBean.getSubMap().containsKey(alarmMap.subKey())) {
        if (watchEnabled) {
          List<String> kk = new ArrayList<>();
          for (String key : smsProcessBean.getSubMap().keySet())
            kk.add(key); 
          logger.info(String.format("告警:SubKey:%s不在订阅列表,订阅信息:[%s]", new Object[] { alarmMap.subKey(), StringUtils.join(kk, ',') }));
        } 
        continue;
      } 
      if (watchEnabled)
        logger.info("监视告警:SubKey == " + alarmMap.subKey() + " 内容:" + alarmMap.getAlarm_str()); 
      String alarmHandlerIgnorePrefix = Constants.getString("dms.msg.sms.handler.ignore.prefix", "SOE时标");
      boolean notHandleRequired = false;
      for (String prefix : alarmHandlerIgnorePrefix.split(";")) {
        if (alarmMap.getAlarm_str().indexOf(prefix) > -1) {
          if (watchEnabled)
            logger.info(String.format("告警:%s 被过滤选项:%s", new Object[] { alarmMap.getAlarm_str(), prefix })); 
          notHandleRequired = true;
          break;
        } 
      } 
      if (notHandleRequired)
        continue; 
      List<String> sendedPhoneList = new ArrayList<>();
      String brkId = String.valueOf(alarmMap.getDev_id());
      if (alarmMap.subKey().equals("8.11")) {
        boolean bFaCHeck = FACheck(brkId, watchEnabled);
        if (!bFaCHeck) {
          if (watchEnabled)
            logger.info(String.format("设备:%s 检测FA挂牌信息，检测结果:不发送", new Object[] { brkId })); 
          continue;
        } 
      } 
      List<SmsPlanBean> smsPlanBeanList = (List<SmsPlanBean>)smsProcessBean.getSubMap().get(alarmMap.subKey());
      if (smsPlanBeanList != null) {
        logger.info("SubKey:" + alarmMap.subKey() + " sms planList size:" + smsPlanBeanList.size());
      } else {
        logger.info("SubKey:" + alarmMap.subKey() + " sms planList Empty!!!");
      } 
      for (SmsPlanBean o : smsPlanBeanList) {
        logger.debug(String.format("处理%s的订阅信息[用户%d,订阅类型:%s，订阅人:%s", new Object[] { alarmMap
                .subKey(), o.getUser_id(), StringUtils.join(o.getdTypes(), ","), StringUtils.join(o.getPhones(), ",") }));
        if (Long.valueOf(brkId).longValue() > 0L) {
          if (!isUsedDev(o, brkId, watchEnabled)) {
            logger.debug("BrkId：" + brkId + " is not used dev");
            continue;
          } 
        } else if (watchEnabled) {
          logger.info(String.format("收到告警:%s 设备:%s 为系统告警，不进行设备有效性检查，直接进入短信发送流程", new Object[] { alarmMap.subKey(), brkId }));
        } 
        if (ParameterUtils.isEmptyOrNull(o.getPhones())) {
          if (watchEnabled)
            logger.info(String.format("订阅信息中没有找到有效的订阅人，subKey%s,template:%s,sendPlan=%d,userId:%d", new Object[] { alarmMap.subKey(), o
                    .getTemplate_id(), o.getSend_plan(), o.getUser_id() })); 
          continue;
        } 
        String recvInferName = alarmMap.getInfer_name();
        if (!ParameterUtils.isEmptyOrNull(o.getPostfix())) {
          if (ParameterUtils.isEmptyOrNull(recvInferName)) {
            Integer posFlag = Constants.getInteger("sms.recvinfername.empty", Integer.valueOf(0));
            if (posFlag.equals(Integer.valueOf(0))) {
              if (watchEnabled)
                logger.info(String.format("当前告警订阅类型:%s 订阅子类型:%s,收到的子类型为空，sms.recvinfername.empty参数为0，不发送短信", new Object[] { alarmMap.subKey(), o.getPostfix() })); 
              continue;
            } 
          } 
          if (o.getPostfix().indexOf(recvInferName) < 0) {
            if (watchEnabled)
              logger.info(String.format("当前告警订阅类型:%s 订阅子类型:%s,收到的子类型:%s 不在订阅列表里面", new Object[] { alarmMap.subKey(), o.getPostfix(), alarmMap.getInfer_name() })); 
            continue;
          } 
        } 
        if (watchEnabled)
          logger.info(String.format("发送计划(用户:%d，短信模板:%s)进入短信发送处理程序", new Object[] { o.getUser_id(), o.getTemplate_id() })); 
        String fileName = "alm-sms-" + ParameterUtils.getUUID().toLowerCase();
        List<String> phoneList = new ArrayList<>();
        for (String p : o.getPhones()) {
          if (sendedPhoneList.contains(p)) {
            logger.debug(String.format("发送计划[用户%d，短信模板:%s] 关联的手机号%s在其他发送计划中已经发送过短信", new Object[] { o.getUser_id(), o.getTemplate_id(), p }));
            continue;
          } 
          sendedPhoneList.add(p);
          phoneList.add(p);
        } 
        logger.info(String.format("发送计划[用户%d，短信模板:%s],生成短信文件[%s]接收人列表[%s]", new Object[] { o.getUser_id(), o.getTemplate_id(), fileName, StringUtils.join(phoneList, ',') }));
        Map<String, Object> dataModel = new HashMap<>();
        dataModel.put("reciveDate", DateUtil.format(alarmMap.getCreateTime()));
        dataModel.put("content", alarmMap.getAlarm_str());
        dataModel.put("fileName", fileName);
        dataModel.put("fileFolder", getOrgCode());
        String sendMethod = Constants.getAppPrefixedPara("message.service.url", "local");
        logger.info("当前短信发送方式: " + sendMethod);
        String reason = "";
        String sendContent = String.format("%s %s", new Object[] { String.valueOf(dataModel.get("reciveDate")), String.valueOf(dataModel.get("content")) });
        if (sendMethod.equals("local")) {
          try {
            if (watchEnabled) {
              logger.info("使用本地文件存储发送短信:" + dataModel.get("fileName"));
              logger.info("当前主站编码: " + getOrgCode());
            } 
            (new DmsMessageSendService()).send(dataModel, sendContent, phoneList);
          } catch (Exception e) {
            reason = "写本地短信文件时异常" + dataModel.get("fileName");
            logger.warn(reason, e);
          } finally {
            WriteSendLog(phoneList, dataModel, reason, String.valueOf(o.getSend_plan()), o.getTemplate_id());
          } 
          continue;
        } 
        if (sendMethod.equals("webservice")) {
          try {
            if (watchEnabled) {
              logger.info("使用WebService发送短信:" + dataModel.get("fileName"));
              logger.info("当前主站编码: " + getOrgCode());
            } 
            SmsWxRestParaHandler handler = new SmsWxRestParaHandler();
            RestClient restClient = new RestClient(SmsWxRestParaHandler.baseUrl);
            restClient.assembleParaHandler((IParaHandler)handler);
            Map<String, String> pathPara = new HashMap<>();
            pathPara.put("fileStr", handler.encrypt(String.valueOf(dataModel.get("content")), phoneList));
            logger.info("短信密文: " + (String)pathPara.get("fileStr"));
            try {
              HttpResponse response = restClient.get("/fa/sendMessage", new HashMap<>(), pathPara);
              logger.info("send sms return info is :" + response.getContent());
              WriteSendLog(phoneList, dataModel, reason, String.valueOf(o.getSend_plan()), o.getTemplate_id());
            } catch (Exception e) {
              e.printStackTrace();
              reason = e.getMessage();
              WriteSendLog(phoneList, dataModel, reason, String.valueOf(o.getSend_plan()), o.getTemplate_id());
            } 
          } catch (Exception e) {
            reason = "写本地短信文件时异常" + dataModel.get("fileName");
            WriteSendLog(phoneList, dataModel, reason, String.valueOf(o.getSend_plan()), o.getTemplate_id());
            logger.warn(reason, e);
          } 
          continue;
        } 
        if (watchEnabled) {
          logger.info("使用RESTFul接口 发送短信:" + dataModel.get("fileName"));
          logger.info("当前主站编码: " + getOrgCode());
        } 
        if (!IMSenderUtil.sendGSMMessage(phoneList.<String>toArray(new String[0]), dataModel, o.getSend_plan(), o.getTemplate_id())) {
          logger.warn(String.format("subKey:%s,设备:%s 短信发送失败", new Object[] { alarmMap.subKey(), brkId }));
          continue;
        } 
        logger.warn(String.format("subKey:%s,设备:%s 提交短信发送请求完成", new Object[] { alarmMap.subKey(), brkId }));
      } 
    } 
  }
  
  private void WriteSendLog(List<String> phoneList, Map<String, Object> dataModel, String reason, String sendPlan, String tempId) {
    String content = String.format("%s %s", new Object[] { String.valueOf(dataModel.get("reciveDate")), String.valueOf(dataModel.get("content")) });
    List<String> sqlList = new ArrayList<>();
    StringBuilder sb = new StringBuilder("insert into sys_msg_content(CONTENT, SEND_PLAN_TIME, VARS_JSON, TEMPLATE_ID) VALUES(");
    sb.append("'").append(content).append("',");
    sb.append(Calendar.getInstance().getTimeInMillis()).append(",");
    sb.append("'").append(JsonUtil.getJsonByObject(dataModel)).append("',");
    sb.append("'").append(tempId).append("'");
    sb.append(")");
    try {
      this.jdbcClient.update(sb.toString());
    } catch (Exception e) {
      e.printStackTrace();
      logger.info("保存日志推送记录错误，sql：" + sb.toString());
      return;
    } 
    List<Map<String, Object>> list = this.jdbcClient.queryForList("select * from sys_msg_content where content='" + content + "'");
    if (list.size() == 0) {
      logger.info("未读取到保存的日志推送记录，内容：" + content);
      return;
    } 
    String contentId = String.valueOf(((Map)list.get(0)).get("id"));
    for (String phone : phoneList) {
      sb = new StringBuilder("insert into sys_msg_history(CONTENT_ID, CREATE_TIME, MSG_TYPE, REASON, RECV_ADDRESS, SENDER_TIME, STATUS) VALUES(");
      sb.append("'").append(contentId).append("',");
      sb.append("'").append(dataModel.get("reciveDate")).append("',");
      sb.append(0).append(",");
      sb.append("'").append(reason).append("',");
      sb.append("'").append(phone).append("',");
      sb.append("'").append(dataModel.get("reciveDate")).append("',");
      sb.append(ParameterUtils.isEmptyOrNull(reason) ? 1 : 0).append(")");
      sqlList.add(sb.toString());
    } 
    if (sqlList.size() > 0)
      try {
        this.jdbcClient.update(sqlList);
      } catch (Exception e) {
        e.printStackTrace();
        logger.info("保存日志推送记录错误，表sys_msg_hstory：sql例子:" + (String)sqlList.get(0));
      }  
  }
  
  private boolean FACheck(String brkId, boolean watchEnabled) {
    boolean bFaCHeck = true;
    Integer faTestUnSend = Constants.getInteger("dms.sms.fa.send", Integer.valueOf(1));
    if (faTestUnSend.equals(Integer.valueOf(1))) {
      if (watchEnabled)
        logger.info("FA测试线路判断是否发送"); 
      String sql = "select status from real_scada_obj_dev where id = " + brkId;
      List<Map<String, Object>> ret = this.rthdbDao.queryForList(sql);
      if (ret.size() == 0) {
        if (brkStatusMap.containsKey(brkId)) {
          if (!((Integer)brkStatusMap.get(brkId)).equals(Integer.valueOf(1))) {
            bFaCHeck = false;
            if (watchEnabled)
              logger.info(String.format("读取设备%s实时状态失败，采用上次状态，上次状态为0，不发送短信", new Object[] { brkId })); 
          } else {
            bFaCHeck = true;
          } 
        } else {
          brkStatusMap.put(brkId, Integer.valueOf(0));
          if (watchEnabled)
            logger.info(String.format("设备%s不在初始化开关列表，重新加入，设置默认状态为0，不发送短信", new Object[] { brkId })); 
          bFaCHeck = false;
        } 
      } else {
        Integer status = Integer.valueOf(String.valueOf(((Map)ret.get(0)).get("status")));
        String bStr = Integer.toBinaryString(status.intValue());
        if (bStr.length() < 13) {
          brkStatusMap.put(brkId, Integer.valueOf(1));
          bFaCHeck = true;
          if (watchEnabled)
            logger.info(String.format("读取设备%s实时状态，当前状态为%d，正常发送短信", new Object[] { brkId, status })); 
        } else if (bStr.charAt(12) == '1') {
          brkStatusMap.put(brkId, Integer.valueOf(0));
          bFaCHeck = false;
          if (watchEnabled)
            logger.info(String.format("读取设备%s实时状态，当前状态为%s，不发送短信", new Object[] { brkId, bStr })); 
        } else {
          brkStatusMap.put(brkId, Integer.valueOf(1));
          bFaCHeck = true;
        } 
      } 
    } else if (watchEnabled) {
      logger.info("FA检测值被改为0，不检测FA线路挂测试牌情况");
    } 
    return bFaCHeck;
  }
  
  private List<AlarmMsgBean> extractAlarmFromMsgContentNew(Map<String, Object> msgData) {
    if (msgData == null) {
      logger.info("短信内容为空");
      return null;
    } 
    List<AlarmMsgBean> ret = new ArrayList<>();
    Object obj = msgData.get("alarm_list");
    if (obj == null || !(obj instanceof List))
      return null; 
    List<Map<String, Object>> list = (List<Map<String, Object>>)obj;
    if (!ParameterUtils.isEmptyOrNull(list)) {
      for (Map<String, Object> map : list) {
        Object tt = map.get("origin_alarm");
        if (tt == null)
          continue; 
        String originAlarmJson = JsonUtil.getJsonByObject(tt);
        AlarmMsgBean alarmMsgBean = (AlarmMsgBean)JsonUtil.getBeanByJson(originAlarmJson, AlarmMsgBean.class);
        if (alarmMsgBean.isValid())
          ret.add(alarmMsgBean); 
      } 
      if (ParameterUtils.isEmptyOrNull(ret))
        logger.info("未解析到短信内容，可能是CS告警结构体缺少inferName所致"); 
      return ret;
    } 
    return null;
  }
  
  private boolean isUsedDev(SmsPlanBean smsPlan, String devId, boolean watchEnabled) {
    if (smsPlan.getDevs().contains(devId)) {
      if (watchEnabled)
        logger.info(String.format("设备:%s是按设备订阅的，在订阅列表，不判断其他权限，直接发送短信", new Object[] { devId })); 
      return true;
    } 
    String strCon = "";
    String filter = "";
    if (devId.startsWith("1021")) {
      String sql = "select filter,container_id from obj_dev where id=" + devId;
      List<Map<String, Object>> list = this.jdbcClient.queryForList(sql);
      if (list.size() == 0) {
        if (watchEnabled)
          logger.info(String.format("设备%s在数据库没有找到", new Object[] { devId })); 
        return false;
      } 
      Object f = ((Map)list.get(0)).get("filter");
      Object conId = ((Map)list.get(0)).get("containerId");
      filter = ParameterUtils.isEmptyOrNull(f) ? "" : String.valueOf(f);
      strCon = ParameterUtils.isEmptyOrNull(conId) ? "" : String.valueOf(conId);
      logger.debug(String.format("设备:%s  类型为:%s 容器:%s", new Object[] { devId, filter, strCon }));
      if (filter.isEmpty() && (ParameterUtils.isEmptyOrNull(strCon) || Long.valueOf(String.valueOf(conId)).longValue() < 0L)) {
        logger.debug(String.format("设备:%s 没有容器也没有类型，也没有被订阅，不发送短信", new Object[] { devId }));
        return false;
      } 
    } else if (devId.startsWith("1007")) {
      String sql = "select container_id from con_feeder where id=" + devId;
      List<Map<String, Object>> list = this.jdbcClient.queryForList(sql);
      if (list.size() == 0) {
        if (watchEnabled)
          logger.info(String.format("馈线%s在数据库没有找到", new Object[] { devId })); 
        return false;
      } 
      Object conId = ((Map)list.get(0)).get("containerId");
      strCon = ParameterUtils.isEmptyOrNull(conId) ? "" : String.valueOf(conId);
    } 
    Integer isAuth = Constants.getInteger("dms.sms.auth", Integer.valueOf(0));
    if (strCon.startsWith("1009") && devId.startsWith("1021")) {
      if (headerBrkMap.containsKey(devId) && isAuth.equals(Integer.valueOf(1))) {
        String headerBrkFeeder = headerBrkMap.get(devId);
        if (((List)smsProcessBean.getUserFeeders().get(smsPlan.getUser_id())).contains(headerBrkFeeder)) {
          String vtStationId = "-1";
          List<Map<String, Object>> stationList = this.jdbcClient.queryForList("select container_id from con_voltagelevel where id=" + strCon);
          if (stationList.size() > 0)
            vtStationId = String.valueOf(((Map)stationList.get(0)).get("containerId")); 
          logger.info(String.format("电压等级%s的容器变电站为：%s", new Object[] { strCon, vtStationId }));
          if (!smsPlan.getdTypes().contains(headerBrkFeeder) && 
            !smsPlan.getdTypes().contains(vtStationId) && 
            !smsPlan.getdTypes().contains(filter) && 
            !smsPlan.getDevs().contains(devId)) {
            if (watchEnabled)
              logger.info(String.format("[带权限验证]设备:%s 是馈线:%s的首开关,馈线在用户%d的权限中,但用户未订阅该设备或变电站或馈线或设备类型，不发送短信", new Object[] { devId, headerBrkFeeder, smsPlan.getUser_id() })); 
            return false;
          } 
          if (watchEnabled)
            logger.info(String.format("[带权限验证]设备:%s 是馈线:%s的首开关,馈线在用户%d的权限中,发送短信", new Object[] { devId, headerBrkFeeder, smsPlan.getUser_id() })); 
          return true;
        } 
        if (watchEnabled)
          logger.info(String.format("[带权限验证]设备:%s 是馈线:%s的首开关,馈线不在用户%d的权限，不发送短信", new Object[] { devId, headerBrkFeeder, smsPlan.getUser_id() })); 
        return false;
      } 
      if (watchEnabled)
        logger.info(String.format("设备:%s 不是首开关,容器不是馈线及变电站，按设备类型判断", new Object[] { devId })); 
      if (!ParameterUtils.isEmptyOrNull(filter) && smsPlan.getdTypes().contains(filter)) {
        if (watchEnabled)
          logger.info(String.format("[设备容器不是厂站或馈线也不是点的告警-按设备类型]设备:%s  类型为:%s 在用户%d的订阅列表", new Object[] { devId, filter, smsPlan.getUser_id() })); 
        return true;
      } 
      if (smsPlan.getDevs().contains(devId)) {
        if (watchEnabled)
          logger.info(String.format("[设备容器不是厂站或馈线也不是点的告警-没有设备类型，是单独订阅的设备]设备:%s  在用户%d的订阅列表", new Object[] { devId, smsPlan.getUser_id() })); 
        return true;
      } 
      if (watchEnabled)
        logger.info(String.format("[设备容器不是厂站或馈线也不是点的告警-按设备类型]设备:%s  类型为:%s 不在用户%d的订阅列表", new Object[] { devId, filter, smsPlan.getUser_id() })); 
    } 
    if (isAuth.intValue() == 0) {
      if (!ParameterUtils.isEmptyOrNull(filter) && smsPlan.getdTypes().contains(filter)) {
        logger.debug(String.format("[不带权限验证-按设备类型]设备:%s  类型为:%s 在用户%d的订阅列表", new Object[] { devId, filter, smsPlan.getUser_id() }));
        return true;
      } 
      Map<String, Object> map = loadFeederAndStation("obj_dev", devId);
      String str1 = map.containsKey("fd") ? String.valueOf(map.get("fd")) : "";
      String str2 = map.containsKey("st") ? String.valueOf(map.get("st")) : "";
      logger.debug(String.format("设备%s,馈线%s,变电站%s", new Object[] { devId, str1, str2 }));
      if (!ParameterUtils.isEmptyOrNull(str1) && smsPlan.getdTypes().contains(str1)) {
        logger.debug(String.format("[不带权限验证-按馈线]设备:%s  馈线为:%s 在用户%d的订阅列表", new Object[] { devId, str1, smsPlan.getUser_id() }));
        return true;
      } 
      if (!ParameterUtils.isEmptyOrNull(str2) && smsPlan.getdTypes().contains(str2)) {
        logger.debug(String.format("[不带权限验证-按厂站]设备:%s  厂站为:%s 在用户%d的订阅列表", new Object[] { devId, str2, smsPlan.getUser_id() }));
        return true;
      } 
      logger.debug(String.format("[不带权限验证]设备:%s  类型为:%s,馈线:%s,厂站:%s 不在订阅列表", new Object[] { devId, filter, str1, str2 }));
      return false;
    } 
    String tmpTable = "obj_dev";
    if (devId.startsWith("1007"))
      tmpTable = "con_feeder"; 
    Map<String, Object> conMap = loadFeederAndStation(tmpTable, devId);
    String feeder = conMap.containsKey("fd") ? String.valueOf(conMap.get("fd")) : "";
    String station = conMap.containsKey("st") ? String.valueOf(conMap.get("st")) : "";
    logger.debug(String.format("设备%s,馈线%s,变电站%s", new Object[] { devId, feeder, station }));
    if (!ParameterUtils.isEmptyOrNull(feeder) && smsPlan.getdTypes().contains(feeder)) {
      if (((List)smsProcessBean.getUserFeeders().get(smsPlan.getUser_id())).contains(feeder)) {
        if (watchEnabled)
          logger.info(String.format("[带权限验证]设备:%s  类型为:%s,馈线:%s,厂站:%s 馈线在用户%d的权限,发送短信", new Object[] { devId, filter, feeder, station, smsPlan.getUser_id() })); 
        return true;
      } 
      if (watchEnabled)
        logger.info(String.format("[带权限验证]设备:%s  类型为:%s,馈线:%s,厂站:%s 馈线或设备不在用户%d的权限，继续判断厂站的权限", new Object[] { devId, filter, feeder, station, smsPlan.getUser_id() })); 
    } else if (!ParameterUtils.isEmptyOrNull(station) && smsPlan.getdTypes().contains(station)) {
      if (((List)smsProcessBean.getUserStations().get(smsPlan.getUser_id())).contains(station)) {
        if (watchEnabled)
          logger.info(String.format("[带权限验证]设备:%s  类型为:%s,馈线:%s,厂站:%s 厂站在用户%d的权限,发送短信", new Object[] { devId, filter, feeder, station, smsPlan.getUser_id() })); 
        return true;
      } 
      if (watchEnabled)
        logger.info(String.format("[带权限验证]设备:%s  类型为:%s,馈线:%s,厂站:%s 厂站不在用户%d的权限，继续判断设备类型", new Object[] { devId, filter, feeder, station, smsPlan.getUser_id() })); 
    } else if (!ParameterUtils.isEmptyOrNull(filter) && smsPlan.getdTypes().contains(filter)) {
      if (((List)smsProcessBean.getUserFeeders().get(smsPlan.getUser_id())).contains(feeder) || ((List)smsProcessBean
        .getUserStations().get(smsPlan.getUser_id())).contains(station))
        return true; 
      logger.debug(String.format("[带权限验证]设备:%s  类型为:%s,馈线:%s,厂站:%s 设备在订阅列表但用户%d没有设备的权限", new Object[] { devId, filter, feeder, station, smsPlan.getUser_id() }));
    } else {
      logger.debug(String.format("[带权限验证]设备:%s  类型为:%s,馈线:%s,厂站:%s 不在用户%d 订阅列表或者没有权限", new Object[] { devId, filter, feeder, station, smsPlan.getUser_id() }));
    } 
    return false;
  }
  
  private Map<String, Object> loadFeederAndStation(String table, String id) {
    Map<String, Object> ret = new HashMap<>();
    if (table == "con_feeder")
      ret.put("fd", id); 
    List<Map<String, Object>> list = this.jdbcClient.queryForList("select container_id,container_tablename from " + table + " where id=" + id);
    for (Map<String, Object> o : list) {
      String conTable = String.valueOf(o.get("containerTablename"));
      String conId = String.valueOf(o.get("containerId"));
      if (ParameterUtils.isEmptyOrNull(conId) || ParameterUtils.isEmptyOrNull(conTable))
        return ret; 
      if (conTable.equals("con_feeder"))
        ret.put("fd", conId); 
      if (conTable.equals("con_station")) {
        ret.put("st", conId);
        return ret;
      } 
      Map<String, Object> ch = loadFeederAndStation(conTable, conId);
      if (!ParameterUtils.isEmptyOrNull(ch.get("fd")))
        ret.put("fd", ch.get("fd")); 
      if (!ParameterUtils.isEmptyOrNull(ch.get("st")))
        ret.put("st", ch.get("st")); 
    } 
    return ret;
  }
}
